{% extends 'base.html' %}

{% block title %}Vue & Django Todo app{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 90px;
        padding-left: 20px;
        line-height: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
        line-height: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
    .removeBtn:hover {
        color: red;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <!--vue.js 에서 data 를 보내므로 form 태그 필요없음-->
    <div class="inputBox">
        <!--v-model=name 과 todo 로 입력받은 데이터를 vue 인스턴스의 data 의 name 과 todo 로 바인딩한다.-->
        <!--model 의 field 와 바인딩될 v-model 이 같아야 한다.-->
        <!--v-model.trim 을 사용하면 입력앞뒤에 공백을 제거하여 대입한다.-->
        <input class="name" type="text" placeholder="이름" v-model.trim="name">
        <input class="item" type="text" placeholder="할 일을 입력하세요~"
               v-model.trim="todo" v-on:keyup.enter="add_todo()">
        <!-- 버튼을 클릭하면 add_todo 메서드를 호출 -->
        <!--추가 버튼을 누르면 클릭 event 수신의 위해 v-on:click 을 사용-->
        <button v-on:click="add_todo()" class="btn btn-primary btn-sm">추가</button>
    </div>

    <ul class="todoList">
        <li v-for="(todo, index) in todoList">
            <span>[[ todo.name ]]:: [[ todo.todo ]]</span>
            <span class="removeBtn" v-on:click="remove_todo(todo, index)">x</span>
        </li>
    </ul>
</div>
{% endblock %}

{% block extra-script %}
<!-- 뷰 CDN 연결 및 Vue instance 생성하기 -->
<script src="https://unpkg.com/vue/dist/vue.min.js"></script>
<!--axios CDN 연결-->
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>
<script>
    axios.defaults.xsrfCookieName = 'csrftoken';
    axios.defaults.xsrfHeaderName = 'X-CSRFToken';

    var vm = new Vue({
        delimiters: ['[[', ']]'],
        /*element option 으로 vue 에 붙어갈 최상의 element 사용 id 가 app 인 태그*/
        el: '#app',
        /*Vue 에 사용 될 변수로 input 태그에 입력받은 v-model 의 data 를 변수에 넣는다.*/
        /*각각 name 과 todo 변수값을 todoList 배열에 push 하게 된다.*/
        data: {
            name: '',
            todo: '',
            todoList: [],
        },
        /*Vue instance 생성시 created hook method 가 호출되고 django 에 axios.get 요청하고
        vue.js 에서는 created, mounted, updated lifecycle hook 제공 */
        created: function () {
            console.log('created(): ');
            /*vue.js 내 this 는 vue instance 를 말하므로 아래 this.fetch_all_todo 는 vue 객체내에
            * fetch_all_todo: function 을 말한다.*/
            this.fetch_all_todo();
        },
        methods: {
            /*axios.get 문법은 url 처리 성공시 callback 함수를 then() 에 넣고 실패시 catch() 에 넣는다.*/
            fetch_all_todo: function () {
                console.log('fetch_all_todo(): ');

                var vm = this;
                /*아래 this 는 axios.get 내의 callback 함수 내에 정의된 것은 windows 객체를 의미하므로
                 * this.todoLIst 는 정의되어 있지 않아 local variable 에 this 를 저장하여 사용하면 된다.*/
                axios.get('/api/todo/list/')
                    .then(function (res) {
                        console.log('GET RES', res);
                        /*this.todoList = res.data;*/
                        vm.todoList = res.data;  // server 로 부터 받은 res 의 data 객체를 vue instance todoList 대입
                    })
                    .catch(function (err) {
                        console.log('GET ERR', err);
                    })
            },
            add_todo: function () {
                console.log("add_todo(): ");
                /*사용자를 입력 안했을 때 무기명넣기 내용이 없으면 리턴*/
                if (this.todo == '') return;
                if (this.name == '') this.name = '익명';

                var vm = this;
                var postData = {name: this.name, todo: this.todo};
                axios.post('/api/todo/create/', postData, {xsrfCookieName: 'csrftoken', xsrfHeaderName: 'X-XSRFToken'})
                    .then(function (res) {
                        console.log('POST RES', res);
                        vm.todoList.push({id: res.data.id, name: res.data.name, todo: res.data.todo});
                    })
                    .catch(function (err) {
                        console.log('POST ERR', err);
                    })
                /*사용자가 입력한 내용 지우기*/
                this.name = this.todo = '';
            },
            remove_todo: function (todo, index) {
                console.log("remove_todo(): ", index);
                if (confirm('정말로 삭제하시겠습니까?') == false) return;
                /*삭제시 index 에 해당하는 것을 한개 삭제*/
                var vm = this;
                axios.delete('/api/todo/' + todo.id + '/delete/')
                    .then(function (res) {
                        console.log('Delete Res', res);
                        vm.todoList.splice(index, 1);
                    })
                    .catch(function (err) {
                        console.log('Delete Err', err);
                    })
            },
        },
    })
</script>
{% endblock %}